#include "defines.h"

OPENFILENAME ofn;
HWND BatchWin, MainWin, QuickWin;

LRESULT CALLBACK QuickWindowProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_CREATE:
		{
			HFONT deffont;
			char nextchar = 0;
			TCHAR *filename = NULL, *found = NULL;
			TCHAR *start = NULL, *end = NULL;
			HWND lstfiles;
			filename = GetCommandLine();
			found = filename;
			deffont = GetStockObject(DEFAULT_GUI_FONT);
			lstfiles = CreateWindowEx(WS_EX_CLIENTEDGE, WC_LISTVIEW, 0, WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_BORDER | LVS_ALIGNLEFT | LVS_REPORT | WS_GROUP, 9, 13, 608, 102, hwnd, NULL, GetModuleHandle(NULL), 0);
			SetupFont(lstfiles,deffont);
			SetupFont(CreateWindowEx(0, WC_BUTTON, L"OK", WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_DEFPUSHBUTTON, 276, 125, 75, 23, hwnd, (HMENU)IDOK, GetModuleHandle(NULL), 0),deffont);
			ListView_AddTextColumn(&lstfiles, L"File", 150, 0);
			ListView_AddTextColumn(&lstfiles, L"Action", 200, 1);
			ListView_AddTextColumn(&lstfiles, L"Directory", 400, 2);
			while ((found = wcschr(found,L'\"')) != NULL)
			{
				TCHAR *temp;
				if (nextchar == 0)
				{
					found[0] = L' ';
					start = found;
				}
				else
				{
					found[0] = L' ';
					end = found;
					temp = malloc(sizeof(TCHAR) * (end-start));
					memset(temp,0,sizeof(TCHAR) * (end-start));
					memcpy(temp,start+1,sizeof(TCHAR) * (end-start-1));
					AddFileToListView(lstfiles,temp);
					free(temp);
				}
				nextchar = nextchar*(-1)+1;
			}
			PatchFilesInListView(lstfiles,NULL);
		}
		break;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
					DestroyWindow(hwnd);
				break;
			}
		break;
		case WM_CLOSE:
			DestroyWindow(hwnd);
		break;
		case WM_DESTROY:
			PostQuitMessage(0);
		break;
		default:
			return DefWindowProc(hwnd,uMsg,wParam,lParam);
	}
	return 0;
}

LRESULT CALLBACK AboutWindowProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_CREATE:
		{
			HFONT deffont;
			deffont = GetStockObject(DEFAULT_GUI_FONT);
			SetupFont(CreateWindow(WC_BUTTON, L"OK", WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_GROUP | BS_DEFPUSHBUTTON, 32, 115, 75, 23, hwnd, (HMENU)IDOK, GetModuleHandle(NULL), 0),deffont);
			SetupFont(CreateWindowEx(0, WC_STATIC, L"ESRPatcher Pro\nAuthor: Insanity5000\n\nESR\nAuthor: ffgriever\n\nPatching Code\nAuthor: bootsector", WS_VISIBLE | WS_CHILD | WS_GROUP | SS_CENTER | WS_TABSTOP, 5, 3, 128, 110, hwnd, NULL, GetModuleHandle(NULL), 0),deffont);
		}
		break;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
					DestroyWindow(hwnd);
				break;
			}
		break;
		case WM_CLOSE:
			DestroyWindow(hwnd);
		break;
		default:
			return DefWindowProc(hwnd,uMsg,wParam,lParam);
	}
	return 0;
}

LRESULT CALLBACK BatchWindowProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static int clearneeded = 0;
	switch (uMsg)
	{
		case WM_KEYDOWN:
		{
			switch (wParam)
			{
				case VK_DELETE:
					if ((keymask & lParam) == 0)
					{
						HWND filelist;
						filelist = GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES));
						ListView_DeleteItem(filelist,ListView_GetSelectionMark(filelist));
					}
				break;
			}
		}
		break;
		case WM_NOTIFY:
		{
			NMHDR *out;
			out = (LPNMHDR)lParam;
			switch (out->code)
			{
				case LVN_KEYDOWN:
					if (out->idFrom == IDC_LSTFILES)
					{
						if (((LPNMLVKEYDOWN)lParam)->wVKey == VK_DELETE)
						{
							HWND filelist;
							filelist = GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES));
							ListView_DeleteItem(filelist,ListView_GetSelectionMark(filelist));
						}
					}
				break;
			}
		}
		break;
		case WM_DROPFILES:
		{
			int amount, i;
			TCHAR FileList[512];
			if (clearneeded == 1)
			{
				SendMessage(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_PROGRESS)),PBM_SETPOS,0,0);
				ListView_DeleteAllItems(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES)));
				clearneeded = 0;
			}
			amount = DragQueryFile((HDROP)wParam,0xFFFFFFFF,FileList,512);
			for (i=0;i<amount;i++)
			{
				DragQueryFile((HDROP)wParam,i,FileList,512);
				AddFileToListView(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES)), FileList);
			}
		}
		break;
		case WM_CREATE:
			{
				HWND lstfiles;
				HFONT deffont;
				deffont = GetStockObject(DEFAULT_GUI_FONT);
				HMODULE mainmod;
				mainmod = GetModuleHandle(NULL);
				SetupFont(CreateWindow(WC_BUTTON,L"Begin",WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_GROUP | BS_DEFPUSHBUTTON,605, 411, 93, 23,hwnd,(HMENU)IDC_BTNBEGIN,mainmod,NULL),deffont);
				SetupFont(CreateWindow(WC_BUTTON, L"Exit", WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON, 699, 411, 93, 23, hwnd, (HMENU)IDC_BTNBEXIT, mainmod, 0),deffont);
				lstfiles = CreateWindowEx(LVS_EX_FULLROWSELECT | WS_EX_CLIENTEDGE,WC_LISTVIEW, 0, WS_VISIBLE | WS_CHILD | WS_TABSTOP | LVS_ALIGNLEFT | LVS_REPORT | WS_HSCROLL | WS_VSCROLL, 3, 3, 788, 372, hwnd, (HMENU)IDC_LSTFILES, mainmod, NULL);
				SetupFont(lstfiles,deffont);
				CreateWindow(PROGRESS_CLASS, 0, WS_VISIBLE | WS_CHILD, 3, 379, 788, 23, hwnd, (HMENU)IDC_PROGRESS, mainmod, NULL);
				SetupFont(CreateWindow(WC_BUTTON, L"Add Files...", WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON, 3, 411, 93, 23, hwnd, (HMENU)IDC_BTNADDFILES, mainmod, NULL),deffont);
				SetupFont(CreateWindow(WC_BUTTON, L"Single File Mode", WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON, 99, 411, 93, 23, hwnd, (HMENU)IDC_BTNSINGLE, mainmod, NULL),deffont);
				SetupFont(CreateWindow(WC_BUTTON, L"Clear", WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON, 351, 411, 93, 23, hwnd, (HMENU)IDC_BTNCLEAR, mainmod, NULL),deffont);
				ListView_AddTextColumn(&lstfiles, L"File", 150, 0);
				ListView_AddTextColumn(&lstfiles, L"Action", 200, 1);
				ListView_AddTextColumn(&lstfiles, L"Directory", 400, 2);
			}
		break;
		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case IDM_OPENFILE:
					SendMessage(hwnd,WM_COMMAND,LOWORD(IDC_BTNADDFILES),0);
				break;
				case IDM_ABOUT:
					ShowAboutDialog(hwnd);
				break;
				case IDM_EXIT:
					SendMessage(hwnd,WM_CLOSE,0,0);
				break;
				case IDM_VIEWSINGLE:
					SendMessage(hwnd,WM_COMMAND,LOWORD(IDC_BTNSINGLE),0);
				break;
				case IDC_BTNCLEAR:
					ListView_DeleteAllItems(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES)));
					SendMessage(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_PROGRESS)),PBM_SETPOS,0,0);
					clearneeded = 0;
				break;
				case IDC_BTNSINGLE:
				{
					HMENU mainmenu;
					mainmenu = GetMenu(hwnd);
					EnableMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWSINGLE),MF_DISABLED | MF_BYCOMMAND | MF_GRAYED);
					EnableMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWBATCH),MF_ENABLED | MF_BYCOMMAND);
					CheckMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWBATCH),MF_UNCHECKED | MF_BYCOMMAND);
					CheckMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWSINGLE),MF_CHECKED | MF_BYCOMMAND);
					ListView_DeleteAllItems(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES)));
					ShowWindow(BatchWin,SW_HIDE);
					ShowWindow(MainWin,SW_SHOW);
				}
				break;
				case IDC_BTNBEGIN:
					if (clearneeded == 1)
					{
						SendMessage(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_PROGRESS)),PBM_SETPOS,0,0);
						ListView_DeleteAllItems(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES)));
						clearneeded = 0;
					}
					else
					{
						clearneeded = 1;
						PatchFilesInListView(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES)),GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_PROGRESS)));
					}
				break;
				case IDC_BTNBEXIT:
					SendMessage(hwnd,WM_CLOSE,0,0);
				break;
				case IDC_BTNADDFILES:
				{
					if (clearneeded == 1)
					{
						SendMessage(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_PROGRESS)),PBM_SETPOS,0,0);
						ListView_DeleteAllItems(GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_LSTFILES)));
						clearneeded = 0;
					}
					ofn.hwndOwner = hwnd;
					GetMultiOpen(&ofn,GetDlgItem(hwnd,IDC_LSTFILES));
				}
				break;
			}
		}
		break;
		case WM_CLOSE:
			DestroyWindow(hwnd);
		break;
		case WM_DESTROY:
			PostQuitMessage(0);
		break;
		default:
			return DefWindowProc(hwnd,uMsg,wParam,lParam);
	}
	return 0;
}

LRESULT CALLBACK MainWindowProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static HWND txtfilename;
	static char mode = 0;
	switch (uMsg)
	{
		case WM_CREATE:
		{
			HMODULE mainmod;
			HFONT deffont;
			mainmod = GetModuleHandle(NULL);
			deffont = GetStockObject(DEFAULT_GUI_FONT);
			SetupFont(CreateWindow(WC_BUTTON,L"File",WS_VISIBLE | WS_CHILD | BS_GROUPBOX,2,3,498,45,hwnd,NULL,(HINSTANCE)mainmod,NULL),deffont);
			txtfilename = CreateWindowEx(WS_EX_CLIENTEDGE,WC_EDIT,L"",WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_GROUP | ES_AUTOHSCROLL | ES_READONLY,6,18,450,24,hwnd,(HMENU)IDC_TXTFILE,(HINSTANCE)mainmod,NULL);
			SetupFont(txtfilename,deffont);
			SetupFont(CreateWindow(WC_BUTTON,L"...",WS_VISIBLE | WS_CHILD | WS_TABSTOP | BS_DEFPUSHBUTTON,460,18,30,24,hwnd,(HMENU)IDC_BTNBROWSE,(HINSTANCE)mainmod,NULL),deffont);
			SetupFont(CreateWindow(WC_BUTTON,L"Process",WS_CHILD | WS_TABSTOP | WS_DISABLED | BS_PUSHBUTTON | WS_VISIBLE,6,60,120,24,hwnd,(HMENU)IDC_BTNPROCESS,(HINSTANCE)mainmod,NULL),deffont);
			SetupFont(CreateWindow(WC_BUTTON,L"Batch File Mode",WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | WS_VISIBLE,136,60,120,24,hwnd,(HMENU)IDC_BTNBATCH,(HINSTANCE)mainmod,NULL),deffont);
			SetupFont(CreateWindow(WC_BUTTON,L"Exit",WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | WS_VISIBLE,379,60,120,24,hwnd,(HMENU)IDC_BTNEXIT,(HINSTANCE)mainmod,NULL),deffont);
		}
		break;
		case WM_DROPFILES:
		{
			TCHAR selectedFiles[512];
			HDROP drophandle;
			memset(selectedFiles,0,sizeof(TCHAR) * 512);
			drophandle = (HDROP)wParam;
			DragQueryFile(drophandle,0,selectedFiles,sizeof(TCHAR) * 512);
			if (SupportedFile(selectedFiles))
			{
				HWND out;
				int checker;
				checker = CheckForPatch(selectedFiles,NULL);
				out = GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_BTNPROCESS));
				SetWindowText(txtfilename,selectedFiles);
				if (checker == ESR_FILE_ALREADY_PATCHED) { mode = 1; }
				else if (checker == ESR_FILE_NOT_PATCHED) { mode = 0; }
				else
				{
					mode = 2;
					if (checker == ESR_FILE_CANNOT_OPEN) { SetWindowText(out,L"Open Failed"); }
					else if (checker == ESR_FILE_NO_UDF_DESCRIPTOR) { SetWindowText(out,L"No UDF Desc."); }
					EnableWindow(out,FALSE);
				}
				if (mode < 2) {
					SetupStatusText(out,mode);
					EnableWindow(out,TRUE);
				}
			}
		}
		break;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDM_EXIT:
					SendMessage(hwnd,WM_CLOSE,0,0);
				break;
				case IDM_OPENFILE:
					SendMessage(hwnd,WM_COMMAND,LOWORD(IDC_BTNBROWSE),0);
				break;
				case IDM_ABOUT:
					ShowAboutDialog(hwnd);
				break;
				case IDM_VIEWBATCH:
					SendMessage(hwnd,WM_COMMAND,LOWORD(IDC_BTNBATCH),0);
				break;
				case IDC_BTNBATCH:
				{
					HMENU mainmenu;
					mainmenu = GetMenu(hwnd);
					EnableMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWBATCH),MF_DISABLED | MF_BYCOMMAND | MF_GRAYED);
					EnableMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWSINGLE),MF_ENABLED | MF_BYCOMMAND);
					CheckMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWSINGLE),MF_UNCHECKED | MF_BYCOMMAND);
					CheckMenuItem(mainmenu,(UINT)MAKEINTRESOURCE(IDM_VIEWBATCH),MF_CHECKED | MF_BYCOMMAND);
					ShowWindow(BatchWin,SW_SHOW);
					ShowWindow(MainWin,SW_HIDE);
				}
				break;
				case IDC_BTNPROCESS:
				{
					int checker;
					TCHAR pfile[512], *outmsg;
					GetWindowText(GetDlgItem(hwnd,IDC_TXTFILE),pfile,512);
					if (!mode) { checker = PatchFile(pfile); outmsg = L"Patch process success"; }
					else if (mode) { checker  = UnPatchFile(pfile); outmsg = L"Unpatch process success"; }
					if (checker == ESR_FILE_OK)
					{
						HWND btnprocess;
						btnprocess = GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_BTNPROCESS));
						MessageBox(hwnd,outmsg,L"Success!",MB_ICONINFORMATION | MB_OK);
						mode = (mode*(-1))+1;
						if (mode) { SetWindowText(btnprocess,L"Unpatch"); }
						else { SetWindowText(btnprocess,L"Patch"); }
					}
					else
					{
						SetWindowText(GetDlgItem(hwnd,IDC_BTNPROCESS),L"Process");
						MessageBox(hwnd,L"An error occurred during the process.",L"Error",MB_ICONERROR | MB_OK);
					}
				}
				break;
				case IDC_BTNEXIT:
					SendMessage(hwnd,WM_CLOSE,0,0);
				case IDC_BTNBROWSE:
				{
					TCHAR filenames[256];
					memset(filenames,0,sizeof(TCHAR) * 256);
					ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST;
					ofn.hwndOwner = hwnd;
					ofn.lpstrFile = filenames;
					if (GetOpenFileName(&ofn) != 0)
					{
						if (SupportedFile(filenames))
						{
							HWND out;
							int checker;
							out = GetDlgItem(hwnd,(int)MAKEINTRESOURCE(IDC_BTNPROCESS));
							checker = CheckForPatch(filenames,NULL);
							SetWindowText(txtfilename,filenames);
							if (checker == ESR_FILE_ALREADY_PATCHED) { mode = 1; }
							else if (checker == ESR_FILE_NOT_PATCHED) { mode = 0; }
							else {
								mode = 2;
								if (checker == ESR_FILE_CANNOT_OPEN) { SetWindowText(out,L"Open Failed"); }
								else if (checker == ESR_FILE_NO_UDF_DESCRIPTOR) { SetWindowText(out,L"No UDF Desc."); }
							}
							if (mode < 2)
							{
								EnableWindow(out,TRUE);
								SetupStatusText(out,mode);
							}
						}
					}
				}
				break;
			}
		break;
		case WM_CLOSE:
			DestroyWindow(hwnd);
		break;
		case WM_DESTROY:
			PostQuitMessage(0);
		break;
		default:
			return DefWindowProc(hwnd,uMsg,wParam,lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG mainmsg;
	if (lpCmdLine[0] == 0)
	{
		HMENU mainmenu, popup1, popup2, popup3;
		mainmenu = CreateMenu();
		popup1 = CreatePopupMenu();
		popup2 = CreatePopupMenu();
		popup3 = CreatePopupMenu();
		AppendMenu(popup1,MF_STRING,(UINT_PTR)IDM_OPENFILE,L"Open File");
		AppendMenu(popup1,MF_SEPARATOR,(UINT_PTR)NULL,L"-");
		AppendMenu(popup1,MF_STRING,(UINT_PTR)IDM_EXIT,L"Exit");
		AppendMenu(mainmenu,MF_STRING | MF_POPUP,(UINT_PTR)popup1,L"File");
		AppendMenu(popup2,MF_STRING | MF_CHECKED | MF_DISABLED | MF_GRAYED,(UINT_PTR)IDM_VIEWSINGLE,L"Single");
		AppendMenu(popup2,MF_STRING | MF_UNCHECKED,(UINT_PTR)IDM_VIEWBATCH,L"Batch");
		AppendMenu(mainmenu,MF_STRING | MF_POPUP,(UINT_PTR)popup2,L"View");
		AppendMenu(popup3,MF_STRING,(UINT_PTR)IDM_ABOUT,L"About");
		AppendMenu(mainmenu,MF_STRING | MF_POPUP,(UINT_PTR)popup3,L"Help");

		WNDCLASSEX winclass, batchclass, aboutclass;
		INITCOMMONCONTROLSEX commctrl;

		winclass.cbSize = sizeof(WNDCLASSEX);
		winclass.style = (UINT)NULL;
		winclass.lpfnWndProc = MainWindowProc;
		winclass.cbClsExtra = 0;
		winclass.cbWndExtra = 0;
		winclass.hInstance = hInstance;
		winclass.hIcon = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);
		winclass.hCursor = LoadCursor(NULL,IDC_ARROW);
		winclass.hbrBackground = (HBRUSH)(COLOR_3DFACE+1);
		winclass.lpszMenuName = NULL;
		winclass.lpszClassName = L"SingleWin";
		winclass.hIconSm = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);

		aboutclass.cbSize = sizeof(WNDCLASSEX);
		aboutclass.style = (UINT)NULL;
		aboutclass.lpfnWndProc = AboutWindowProc;
		aboutclass.cbClsExtra = 0;
		aboutclass.cbWndExtra = 0;
		aboutclass.hInstance = hInstance;
		aboutclass.hIcon = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);
		aboutclass.hCursor = LoadCursor(NULL,IDC_ARROW);
		aboutclass.hbrBackground = (HBRUSH)(COLOR_3DFACE+1);
		aboutclass.lpszMenuName = NULL;
		aboutclass.lpszClassName = L"AboutWin";
		aboutclass.hIconSm = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);

		batchclass.cbSize = sizeof(WNDCLASSEX);
		batchclass.style = (UINT)NULL;
		batchclass.lpfnWndProc = BatchWindowProc;
		batchclass.cbClsExtra = 0;
		batchclass.cbWndExtra = 0;
		batchclass.hInstance = hInstance;
		batchclass.hCursor = LoadCursor(NULL,IDC_ARROW);
		batchclass.hIcon = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);
		batchclass.hbrBackground = (HBRUSH)(COLOR_3DFACE+1);
		batchclass.lpszMenuName = NULL;
		batchclass.lpszClassName = L"BatchWin";
		batchclass.hIconSm = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);

		memset(&ofn,0,sizeof(OPENFILENAME));
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hInstance = hInstance;
		ofn.lpstrFilter = L"All supported files (*.iso; *.bin; *.mdf)\0*.bin;*.iso;*.mdf\0ISO Files (*.iso)\0*.iso\0MDF Files (*.mdf)\0*.mdf\0BIN Files (*.bin)\0*.bin\0";
		ofn.nMaxFile = sizeof(TCHAR) * 256;
		ofn.lpstrInitialDir = L".\\";
		ofn.lpstrTitle = L"Open Image";

		commctrl.dwSize = sizeof(INITCOMMONCONTROLSEX);
		commctrl.dwICC = ICC_WIN95_CLASSES;
		InitCommonControlsEx(&commctrl);

		if ((!RegisterClassEx(&winclass)) || (!RegisterClassEx(&batchclass)) || (!RegisterClassEx(&aboutclass)))
		{
			MessageBox(NULL,L"Failed to register window classes",L"Error",MB_ICONERROR | MB_OK);
			return 1;
		}
		MainWin = CreateWindowEx(WS_EX_ACCEPTFILES | WS_EX_CONTROLPARENT,L"SingleWin",L"ESRPatcher Pro - Single File Mode",WS_MINIMIZEBOX | WS_SYSMENU | WS_DLGFRAME | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,509,145,NULL,NULL,hInstance,NULL);
		BatchWin = CreateWindowEx(WS_EX_ACCEPTFILES | WS_EX_CONTROLPARENT,L"BatchWin",L"ESRPatcher Pro - Batch File Mode",WS_MINIMIZEBOX | WS_DLGFRAME | WS_SYSMENU,CW_USEDEFAULT,CW_USEDEFAULT,801,495,NULL,NULL,hInstance,NULL);
		if ((MainWin == NULL) || (BatchWin == NULL))
		{
			MessageBox(NULL,L"Failure to Create window",L"Error",MB_ICONERROR | MB_OK);
			return 1;
		}
		SetMenu(MainWin,mainmenu);
		SetMenu(BatchWin,mainmenu);
	}
	else
	{
		WNDCLASSEX quickclass;
		quickclass.cbSize = sizeof(WNDCLASSEX);
		quickclass.style = (UINT)NULL;
		quickclass.lpfnWndProc = QuickWindowProc;
		quickclass.cbClsExtra = 0;
		quickclass.cbWndExtra = 0;
		quickclass.hInstance = hInstance;
		quickclass.hIcon = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);
		quickclass.hCursor = LoadCursor(NULL,IDC_ARROW);
		quickclass.hbrBackground = (HBRUSH)(COLOR_3DFACE+1);
		quickclass.lpszMenuName = NULL;
		quickclass.lpszClassName = L"ParamWin";
		quickclass.hIconSm = LoadIcon(hInstance,(LPCTSTR)IDI_ICON1);

		if (!RegisterClassEx(&quickclass))
		{
			MessageBox(NULL,L"Failure to register window class",L"Error",MB_ICONERROR | MB_OK);
			return 1;
		}
		QuickWin = CreateWindowEx(WS_EX_CONTROLPARENT,L"ParamWin",L"Output", WS_VISIBLE | WS_MINIMIZEBOX | WS_SYSMENU, CW_USEDEFAULT, CW_USEDEFAULT, 633, 186, NULL, NULL, hInstance, NULL);
		if (QuickWin == NULL)
		{
			MessageBox(NULL,L"Failed to create window",L"Error",MB_ICONERROR | MB_OK);
			return 1;
		}
	}
	while (GetMessage(&mainmsg,NULL,0,0) > 0)
	{
		if (!IsDialogMessage(GetActiveWindow(),&mainmsg))
		{
			TranslateMessage(&mainmsg);
			DispatchMessage(&mainmsg);
		}
	}
	return mainmsg.wParam;
}

void SetupStatusText(HWND status, char mode)
{
	if (mode == 0) { SetWindowText(status,L"Patch"); }
	else if (mode == 1) { SetWindowText(status,L"Unpatch"); }
}

void chrtoup(TCHAR *str)
{
	int slen, i;
	slen = wcslen(str);
	for (i=0;i<slen;i++)
	{
		str[i] = towupper(str[i]);
	}
}

char SupportedFile(TCHAR *filename)
{
	TCHAR *extension, extcmp[4];
	extension = wcsrchr(filename,L'.');
	extension += 1;
	memcpy(extcmp,extension,sizeof(TCHAR) * 4);
	extcmp[3] = 0;
	chrtoup(extcmp);
	if (wcscmp(extcmp,L"ISO") == 0) { return 1; }
	else if (wcscmp(extcmp,L"BIN") == 0) { return 1; }
	else if (wcscmp(extcmp,L"MDF") == 0) { return 1; }
	else { return 0; }
}

int AddFileToListView(HWND listview, TCHAR *filename)
{
	if (SupportedFile(filename) == 1)
	{
		int i, check, inserted;
		char add = 1;
		TCHAR *remove;
		LVITEM newitem;
		newitem.mask = LVIF_TEXT;
		newitem.iItem = 0;
		newitem.iSubItem = 0;
		check = CheckForPatch(filename,NULL);
		remove = wcsrchr(filename,L'\\');
		*remove = 0;
		newitem.pszText = remove+1;
		for (i=0;i<ListView_GetItemCount(listview);i++)
		{
			TCHAR inlist[512];
			memset(inlist,0,sizeof(TCHAR) * 512);
			ListView_GetItemText(listview,i,0,inlist,sizeof(TCHAR) * 512);
			if (wcscmp(remove+1,inlist) == 0)
			{
				ListView_GetItemText(listview,i,2,inlist,sizeof(TCHAR) * 512);
				if (wcscmp(filename,inlist) == 0) { add = 0; }
			}
		}
		if (add == 1)
		{
			inserted = ListView_InsertItem(listview,&newitem);
			if (check == ESR_FILE_NOT_PATCHED) { ListView_SetItemText(listview,inserted,1,L"Patch"); }
			else if (check == ESR_FILE_ALREADY_PATCHED) { ListView_SetItemText(listview,inserted,1,L"Unpatch"); }
			else { ListView_SetItemText(listview,inserted,1,L"Cannot Patch"); }
			ListView_SetItemText(listview,inserted,2,filename);
			return inserted;
		}
		else { return -1; }
	}
	return -1;
}

void GetMultiOpen(OPENFILENAME *openfile, HWND addtolst)
{
	TCHAR selectedFiles[512];
	memset(selectedFiles,0,sizeof(TCHAR) * 512);
	openfile->Flags = OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_FILEMUSTEXIST;
	openfile->lpstrFile = selectedFiles;
	if (GetOpenFileName(openfile))
	{
		int curcheck;
		curcheck = openfile->nFileOffset;
		if (selectedFiles[curcheck-1] == 0)
		{
			while (wcslen(selectedFiles+curcheck) != 0)
			{
				TCHAR fullfile[512];
				memset(fullfile,0,sizeof(TCHAR) * 512);
				wcscat(fullfile,selectedFiles);
				wcscat(fullfile,L"\\");
				wcscat(fullfile,selectedFiles+curcheck);
				AddFileToListView(addtolst,fullfile);
				curcheck+=wcslen(selectedFiles+curcheck)+1;
			}
		}
		else
				AddFileToListView(addtolst,selectedFiles);
	}
}

int ShowAboutDialog(HWND owner)
{
	HWND aboutdlg;
	MSG aboutmsg;
	aboutdlg = CreateWindow(L"AboutWin",L"About",WS_DLGFRAME | WS_SYSMENU | WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,143,173,owner,NULL,GetModuleHandle(NULL),NULL);
	EnableWindow(owner,FALSE);
	while (GetMessage(&aboutmsg,aboutdlg,0,0) > 0)
	{
		TranslateMessage(&aboutmsg);
		DispatchMessage(&aboutmsg);
	}
	EnableWindow(owner,TRUE);
	return aboutmsg.wParam;
}

void ListView_AddTextColumn(HWND *listview, TCHAR *text, int width, int columnno)
{
	LVCOLUMN column;
	column.mask = LVCF_TEXT | LVCF_WIDTH;
	column.pszText = text;
	column.cx = width;
	ListView_InsertColumn(*listview,columnno,&column);
}

void SetupFont(HWND replace, HFONT made)
{
	SendMessage(replace,WM_SETFONT,(WPARAM)made,LOWORD(TRUE));
}

void PatchFilesInListView(HWND listview, HWND progressbar)
{
	int filecount, i;
	TCHAR dir[512], file[512], ready[1024];
	TCHAR mode[13];
	filecount = ListView_GetItemCount(listview);
	SendMessage(progressbar,PBM_SETRANGE,0,MAKELPARAM(0,filecount));
	SendMessage(progressbar,PBM_SETPOS,0,0);
	for (i=0;i<filecount;i++)
	{
		LVITEM specs;
		SendMessage(progressbar,PBM_SETPOS,i,0);
		memset(&(ready[0]),0,sizeof(TCHAR) * 1024);
		memset(&(mode[0]),0,sizeof(TCHAR) * 13);
		memset(&(dir[0]),0,sizeof(TCHAR) * 512);
		memset(&(file[0]),0,sizeof(TCHAR) * 512);
		specs.iItem = i;
		specs.iSubItem = 2;
		specs.mask = LVIF_TEXT;
		specs.pszText = dir;
		specs.cchTextMax = 512;
		ListView_GetItem(listview,&specs);
		specs.iSubItem = 0;
		specs.pszText = file;
		ListView_GetItem(listview,&specs);
		wcscat(ready,dir);
		wcscat(ready,L"\\");
		wcscat(ready,file);
		specs.iSubItem = 1;
		specs.pszText = mode;
		specs.cchTextMax = 13;
		ListView_GetItem(listview,&specs);
		if (mode[0] == L'P')
		{
			if (PatchFile(ready) == 0)
			{
				mode[5] = L'e';
				mode[6] = L'd';
				mode[7] = 0;
			}
			else { wcscpy(mode,L"Failure"); }
		}
		else if (mode[0] == L'U')
		{
			if (UnPatchFile(ready) == 0)
			{
				mode[7] = L'e';
				mode[8]	= L'd';
				mode[9] = 0;
			}
			else { wcscpy(mode,L"Failure"); }
		}
		ListView_SetItemText(listview,i,1,mode);
	}
	SendMessage(progressbar,PBM_SETPOS,filecount,0);
}
